package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.GP_PricingRutaDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingRuta;
import com.rjconsultores.ventaboletos.entidad.Ruta;

@Repository("gp_pricingRutaDAO")
public class GP_PricingRutaHibernateDAO extends GenericHibernateDAO<GP_PricingRuta, Integer>
		implements GP_PricingRutaDAO {

	@Autowired
	public GP_PricingRutaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<GP_PricingRuta> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, GP_Pricing.ATIVO));

		return c.list();
	}

	public Boolean obtenerPricingRuta(GP_Pricing pricing, Ruta ruta) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, GP_Pricing.ATIVO));
		c.add(Restrictions.eq("pricing", pricing));
		c.add(Restrictions.eq("ruta", ruta));

		if (c.list().size() > 0) {
			return true;
		} else {
			return false;
		}
	}

	@Override
	public List<GP_PricingRuta> obtenerTodoPorPricing(GP_Pricing pricing) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("pricing.pricingId", pricing.getPricingId()));

		return c.list();
	}
}
